#include "qtdeployer.h"
#include "./ui_qtdeployer.h"
#include <QFile>
#include <QTextStream>
#include <QDebug>
#include <QFileDialog>
#include <QtCore/QCoreApplication>
#include <QProcess>
#include <QThread>



QtDeployer::QtDeployer(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::QtDeployer)
{
    ui->setupUi(this);
    setWindowIcon(QIcon("l_qt_deployer.png"));
    setWindowFlags(Qt::Dialog | Qt::MSWindowsFixedSizeDialogHint); //Данная строчка запрещает изменение размеров окна

    formAbout = new about;
    password = new Password;

    ui->textEdit->setTextColor( QColor( "white" ) );
    ui->tE2->setTextColor( QColor( "white" ) );


    connect(ui->installBtn, SIGNAL(clicked()), this, SLOT(install()));
    connect(ui->fileBtn,    SIGNAL(clicked()), this, SLOT(openFile()));
    connect(ui->makeBtn,    SIGNAL(clicked()), this, SLOT(makeProgram()));
    connect(ui->simlinkBtn, SIGNAL(clicked()), this, SLOT(simLink()));
    connect(ui->aboutBtn,   SIGNAL(clicked()), this, SLOT(About()));
    connect(password, &Password::signalPasswd, this, &QtDeployer::slotPasswd); //Данное выражение получает сигнал из второй формы

    ui->checkBox->setChecked(true);



    ui->tE2->setText("Выберете release-файл вашей программы!");


    if (FN ==""){
        ui->textEdit->setText("\r\n\r\n\r\n\https://madmentat.ru");
        QTextCursor Cursor = ui->textEdit->textCursor();
        Cursor.movePosition(QTextCursor::End);
        ui->textEdit->setTextCursor(Cursor);
        ui->textEdit->setAlignment(Qt::AlignCenter);
    }
    else{
        ui->textEdit->setAlignment(Qt::AlignJustify);
    }


    if (!QFile("/usr/local/bin/linuxdeployqt").exists()){
        ui->textEdit->setText("Внимание! Программа linuxdeployqt не установлена, а без нее ничего не заработает! Чтобы решить эту проблему, нажмите на соответствующую кнопку в самом низу данной формы. Установка будет произведена в папку /usr/local/bin, поэтому QtDeployer спросит у вас пароль суперпользователя. Не ссыте, это безопасно. Вроде бы...");
        ui->textEdit->setAlignment(Qt::AlignJustify);
        this->resize(400, 360);
    }
    else{
        this->resize(400, 320);

    }

}

QtDeployer::~QtDeployer()
{
    delete ui;
}

void QtDeployer::install()
{    
    if (QFile("/usr/local/bin/linuxdeployqt").exists()){
      ui->tE2->setText("Программа уже установлена!");
    }
    else {
      password->show();
    }
}

void QtDeployer::openFile()
{
    //далее новый вариант открытия файла где можно выбрать тип файла
    ui->textEdit->setTextColor( QColor( "white" ) );
    ui->textEdit->setText(" ");

         QString fileName = QFileDialog::getOpenFileName(this,
                                            QString("Открыть файл"),
                                            QDir::currentPath(),
                                     "Все файлы (*)");
         FN=fileName; //Запись имени файла в глобальную переменную FN
         QFile file(fileName);
         if (!file.open(QIODevice::ReadOnly | QIODevice::Text))
                 return;
         qDebug() << "Ошибка при открытии файла";
         QTextStream in(&file);

        // ui->textEdit->setText(in.readAll()); //Вывод в текстовое поле содержимое читаемого файла
         ui->tE2->setText("");

         glibc_check();
         ui->tE2->setText("Все готово к сборке! Нажмите соответствующую кнопку!");

#if defined(Q_OS_WIN)
    #define qUsername QString::fromLocal8Bit (qgetenv ("USERNAME").constData ()).toUtf8 ()
#elif defined(Q_OS_UNIX)
    #define qUsername qgetenv("USER").constData ()
#endif
         ui->textEdit->setAlignment(Qt::AlignJustify);

}

void QtDeployer::makeProgram()
{
    if (FN ==""){
        ui->tE2->setText("Release-файл вашей программы не выбран!");

    }
    else{
        QString command = ui->textEdit->toPlainText();
        QProcess *console=new QProcess();
        console->startDetached(command);
        ui->tE2->setText("Процесс пошел!");
        ui->textEdit->setText("Дождитесь, пока ваша программа соберется. Обычно этот процесс занимает несколько секунд, в зависимости от сложности проекта.");
        ui->textEdit->setAlignment(Qt::AlignJustify);
    }
}


void QtDeployer::simLink()
{

}

void QtDeployer::About()
{
    formAbout->show();
}

void QtDeployer::glibc_check()
{
        if(!ui->checkBox->isChecked())
        {
            ui->textEdit->clear();
            ui->textEdit->setText(("linuxdeployqt " + FN));
            //ui->tE2->setText("the box is unchecked");
        }
        else {
            ui->textEdit->clear();
            ui->textEdit->setText(("linuxdeployqt " + FN + " -unsupported-allow-new-glibc"));
            //ui->tE2->setText("the box is checked");
        }
        ui->textEdit->setAlignment(Qt::AlignJustify);
}

void QtDeployer::FNcheck()
{
    if (FN ==""){
        ui->textEdit->setText("\r\n\r\n\r\n\https://madmentat.ru");
        QTextCursor Cursor = ui->textEdit->textCursor();
        Cursor.movePosition(QTextCursor::End);
        ui->textEdit->setTextCursor(Cursor);
        ui->textEdit->setAlignment(Qt::AlignCenter);
    }
    else {
        glibc_check();
    }
}



void QtDeployer::on_checkBox_stateChanged()
{
FNcheck();
}

void QtDeployer::keyPressEvent(QKeyEvent *event)
{
    int key=event->key();                   //event->key() - целочисленный код клавиши
    QString str = QString(QChar(key));
    if (key>=Qt::Key_0 && key<=Qt::Key_F1) { //Цифровые клавиши 0..9
    formAbout->show();
    }

}

void QtDeployer::slotPasswd(QString pswd)
{
    PASSWORD = pswd;

    QProcess *console=new QProcess();
    QString command1, command2, command3, command4;
    command1 = "touch linuxdeployqt.sh";
    command2 = "chmod +x linuxdeployqt.sh";

    console->startDetached(command1);
    console->startDetached(command2);

    QFile file("linuxdeployqt.sh");
    if (!file.open(QIODevice::WriteOnly | QIODevice::Text))
            return;
        QTextStream out(&file); //поток для записи текста
        //out << "!#/bin/bash\r\necho " + PASSWORD + " | sudo -S touch 1";
        out << "!#/bin/bash\r\necho " + PASSWORD + " | sudo -S cp linuxdeployqt.AppImage /usr/local/bin/linuxdeployqt";
    file.close();


    command3 = "sh linuxdeployqt.sh";
    command4 = "rm linuxdeployqt.sh";
    console->startDetached(command3);
    console->startDetached(command4);


    ui->tE2->setText("Готово!");


    FNcheck();
    this->resize(400, 320);

}

